// ChildView.h : interface of the CChildView class
//


#pragma once
#include "pack.h"
#include "vector"
#include "algorithm"
#include "NameDlg.h"
#include "gamestatistics.h"
#include "custommenu.h"
#include "decoration.h"


struct CARD
{
	card(){mast = 0; value = 0;}
	void reset(){mast = 0; value = 0; pos_value = 0;}
	char mast;
	char value;
	char pos_value;
};

// CChildView window

class CChildView : public CWnd
{
// Construction
public:
	CChildView();

// Overrides
	protected:
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);

// Implementation
public:
	virtual ~CChildView();

	// Generated message map functions
protected:
	DECLARE_MESSAGE_MAP()
public:
	afx_msg void OnFileNewparty();
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnFileSetplayersnames();
	afx_msg void OnContextMenu(CWnd* /*pWnd*/, CPoint /*point*/);
	afx_msg void OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);   
	afx_msg void OnSetting();   
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnTimer(UINT nIDEvent); 
	afx_msg BOOL OnEraseBkgnd(CDC* pDC);
	afx_msg void OnFileNextgame();
	afx_msg void OnUpdateFileNextgame(CCmdUI *pCmdUI);
	afx_msg void OnFileStatistics();

	//  
	void BeginGame(void);
	//  
	void GoUser(/*CCard* pCard*/);
	//   
	void GoComp(void);
	//  
	void RollingPlayer(void);
	//    
	void ContinueGame(void);
	//   
	bool IsStopGame(void);
	void TestAnim(void);
	//     
	void RollingUser(void);
	//   
	void OnEndGame(void);
	//   ,    
	void StopGame(void);
	//   
	void NewParty(void);
	
	//   
	int m_CountProcess;
	//     
	//bool m_PermitNewParty;

private:
	//  			   
	void DistrCards(const int& distr_player);
	//     
	LRESULT OnCardLButtonDown(WPARAM wParam, LPARAM lParam);
	//       
	bool IsCanGo(const int go_player);
	//      
	bool IsEndCards(const int player);
	//      
	//       
	void AlgorithmPosValue(void);
	//        
	void ComputePosValue(const int player, const int mast);
	//   OnSize
	void DoEvent_OnSize(void);
	//      
	void ResetNewParty(void);
	//   
	bool IsEndParty(void);
	//        
	LRESULT OnPublicSetting(WPARAM wParam, LPARAM lParam);
	//    
	void ReadSettingFromReg(void);
	//      
	void WriteSettingToReg(void);
	//     
	bool DeterminationGoingPlayer(void); 
					

	//      ,
	//          
	CDecoration m_Decoration;
	//  
	CGameStatistics m_wndGameStatistics;
	//     
	int CoordinateCardsTable[4][9];
	//     ,
	//        
	CCard* m_pCardUser;
	//       
	bool m_StopProcess;
	//       
	BOOL m_EnableNextGame;
	//       
	BOOL m_EnableNewParty;
	//  
	int m_GOINGPLAYER;
	std::vector<CARD> m_GoCards;
	//   
	int m_NumberGames;

public:
	//   
	void OnHelpApp(void);
};

