// ChildView.h : interface of the CChildView class
//


#pragma once
#include "directplay.h"
#include "ipcompinfo.h"
#include "NameDlg.h"
#include "pack.h"
#include "banks.h"
//#include "label.h"
#include "decoration.h"
#include "custommenu.h"
#include "Adjustment.h"
#include "searchplayers.h"
#include "GameStatistics.h"
#include "chattablo.h"
#include "MessageBox.h"


//    
//   
struct card
{
	card(){reset();}
	void reset(){mast = 0; value = 0;}
	char mast;
	char value;
};

//        
struct MSG_SAFE : MSG_TYPE
{
	MSG_SAFE() {pParent = NULL; id_player = 0;}
	CWnd* pParent;
	UINT id_player;
};

// CChildView window

class CChildView : public CWnd
{
// Construction
public:
	CChildView();


// Overrides
	protected:
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);

// Implementation
public:
	virtual ~CChildView();

	// Generated message map functions
protected:
	DECLARE_MESSAGE_MAP()


public:
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnFileSetname();
	afx_msg void OnFileStatistics();
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg void OnSetting();
	afx_msg BOOL OnEraseBkgnd(CDC* pDC);
	afx_msg void OnFileNextgame();
	afx_msg void OnContextMenu(CWnd* /*pWnd*/, CPoint /*point*/);
	afx_msg void OnUpdateFileNewparty(CCmdUI *pCmdUI);
	afx_msg void OnUpdateFileNextgame(CCmdUI *pCmdUI);
	afx_msg void OnNetDogame();
	afx_msg void OnFileNewparty();

	//        
	LRESULT OnPublicSetting(WPARAM wParam, LPARAM lParam);

	//    
	LRESULT On_DPN_MSGID_CONNECT_COMPLETE(WPARAM wParam, LPARAM lParam);
	LRESULT On_DPN_MSGID_INDICATE_CONNECT(WPARAM wParam, LPARAM lParam);
	LRESULT On_DPN_MSGID_CREATE_PLAYER(WPARAM wParam, LPARAM lParam);
	LRESULT On_DPN_MSGID_DESTROY_PLAYER(WPARAM wParam, LPARAM lParam);
	LRESULT On_DPN_MSGID_PEER_INFO(WPARAM wParam, LPARAM lParam);
	LRESULT On_MSGSERVICEGAME(WPARAM wParam, LPARAM lParam);

	//     
	//     
	LRESULT On_MSGCHECKIDLE(WPARAM wParam, LPARAM lParam);

	//     
	LRESULT OnCardLButtonDown(WPARAM wParam, LPARAM lParam);
	//          
	LRESULT OnMyEditOnEnChange(WPARAM wParam, LPARAM lParam);
	
	// ---    ---
	void SendNewParty(void);
	void SendNextGame(void);
	void SendDistrCards(void);
	//    
	void SendRollingPlayer(void);
	//    ,       
	void SendSafeMessage(const int& select_function);
	//      
	void SendRequestIdle(void);
	//       
	void SendInitPlayers(void);
	//      , 
	//          
	void SelectSendFunction(const int& sel_func);
	void SendGoPlayer(void);
	//     
	void SendGoCard(void);
	//   
	void SendInitNewPlayers(void);
	void SendDataNewPlayers(void);
	//     
	void SendReInitPlayers(void);
	//   
	void SendStopProcess(void);
	

	// ---   ---
	//  
	void RollingPlayer(void);
	//      
	void ResetNewParty(void);
	//   
	void NewParty(void);
	//   
	void NextGame(void);
	//  
	void BeginGame(void);
	//  
	bool DistrCards(const int& distr_player, char mast[36], char value[36]);
	//     
	void RollingUser(void);
	void GoUser(void);
	//       
	bool IsCanGo(const int go_player);
	//      
	bool IsEndCards(const int player);
	//   
	bool IsEndMoney(void);
	//   
	void OnEndGame(void);
	bool DeterminationGoingPlayer(void);
	//   ?
	bool IsEndParty(void){return m_EnableNewParty;}

	// ---       ---
	void GoCardForNet(void);
	void RollForNet(void);

	//   .
	void SetStatistics(void);
	//   OnSize().
	void DoOnSize(void);
	//   ,    
	void StopGame(void);
	//   
	bool IsStopGame(void);
	void ContinueGame(void);
	//   
	void OnHelpApp(void);

	//        
	bool IsAllowActiveChildView(void){return m_AllowActiveChildView;}
	void SetAllowActiveChildView(bool allow) {m_AllowActiveChildView = allow;}

	//     
	CDecoration m_Decoration;
	//   .
	CDirectPlay m_DirectPlay;
	//    .
	CSearchPlayers m_SearchPlayers;
	//  .
	CGameStatistics m_wndGameStatistics;
	//     
	CCard* m_pCardUser;
	//       .
	DATA_CARD m_DataCard;

	//   
	bool m_DistrOk;
	//      .
	int m_CountProcess;

	
private:
	void ReadSettingFromReg(void);
	void WriteSettingToReg(void);
	
	//  
	int m_GOINGPLAYER;
	//   
	int m_NumberGames;
	//     .
	std::vector<card> m_GoCards;
	// ,  ,   
	//   .
	bool m_bLocalPlayer;
	//  
	CChatTablo m_wndChatTablo;
	//      
	std::vector<int> m_vecMsg;
	//     (,   ..)
	bool m_StopProcess;
	//    ( )     
	BOOL m_EnableNextGame;
	bool m_EnableNewParty;
	//        
	bool m_AllowActiveChildView;
	//   ,        "" 
	//  false  GoUser(),      GoCardForNet()
	bool m_AllowGoCard;
	
};



