// ConnectDlg.cpp : implementation file
//

#include "stdafx.h"
#include "NineKNet1.h"
#include "ConnectDlg.h"
#include ".\connectdlg.h"


// CConnectDlg dialog
IMPLEMENT_DYNAMIC(CConnectDlg, CDialog)
CConnectDlg::CConnectDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CConnectDlg::IDD, pParent)
	, m_AutoConnect(TRUE)
	, m_CreateGame(TRUE)
	, m_NumberPort(0)
	, m_IP("127.0.0.1")
	, m_IsConnect(FALSE)
	, m_Caption(_T(" "))
{	
}

CConnectDlg::~CConnectDlg()
{
}

BEGIN_MESSAGE_MAP(CConnectDlg, CDialog)
	ON_BN_CLICKED(IDC_RADIO_AUTOCONNECT, OnBnClickedRadioAutoconnect)
	ON_BN_CLICKED(IDC_RADIO_MANUALCONNECT, OnBnClickedRadioManualconnect)
	ON_BN_CLICKED(IDC_RADIO_CREATEGAME, OnBnClickedRadioCreategame)
	ON_BN_CLICKED(IDC_RADIO_CONNECTGAME, OnBnClickedRadioConnectgame)
END_MESSAGE_MAP()


// CConnectDlg message handlers
BOOL CConnectDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	//   .
	SetWindowText(m_Caption);

	//    .
	CString s;
	s.Format("%d", m_NumberPort);
	GetDlgItem(IDC_EDIT_NUMBERPORT)->SetWindowText(s);


	//       
	//   .
	PrepareAutoConnect(m_AutoConnect);
	PrepareCreateGame(m_CreateGame);

	//   IP-  .
	if(m_vecListIP.size() > 0)
	{
		GetDlgItem(IDC_COMBO_IP)->SetWindowText(m_vecListIP[0]);
		for(int i = 0; i < m_vecListIP.size(); i++)
		{
			((CComboBox*)GetDlgItem(IDC_COMBO_IP))->InsertString(i, m_vecListIP[i]);
		}
		m_vecListIP.clear();
	}
	
	//        ,
	// ..     .
	SetDisconnect(m_IsConnect);

	

	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}



/////////////////////////////////////////////////////////////
//      .
void CConnectDlg::OnBnClickedRadioAutoconnect()
{
	m_AutoConnect = TRUE;
	PrepareAutoConnect(m_AutoConnect);
}

//    .
void CConnectDlg::OnBnClickedRadioManualconnect()
{
	m_AutoConnect = FALSE;
	PrepareAutoConnect(m_AutoConnect);
}

////////////////////////////////////////////////////////////////
//       ,
//     
void CConnectDlg::OnBnClickedRadioCreategame()
{
	m_CreateGame = TRUE;
}

void CConnectDlg::OnBnClickedRadioConnectgame()
{
	m_CreateGame = FALSE;
}


//          
void CConnectDlg::PrepareAutoConnect(BOOL autoconnect)
{
	((CButton*)GetDlgItem(IDC_RADIO_AUTOCONNECT))->SetCheck(autoconnect/*BST_CHECKED=1*/);
	((CButton*)GetDlgItem(IDC_RADIO_MANUALCONNECT))->SetCheck(!autoconnect/*BST_UNCHECKED=0*/);

	//       
	//  
	GetDlgItem(IDC_RADIO_CREATEGAME)->EnableWindow(!autoconnect);
	GetDlgItem(IDC_RADIO_CONNECTGAME)->EnableWindow(!autoconnect);
	GetDlgItem(IDC_STATIC_TEXTIP)->EnableWindow(!autoconnect);
	GetDlgItem(IDC_STATIC_TEXTNUMBERPORT)->EnableWindow(!autoconnect);
	GetDlgItem(IDC_COMBO_IP)->EnableWindow(!autoconnect);
	GetDlgItem(IDC_EDIT_NUMBERPORT)->EnableWindow(!autoconnect);
}

void CConnectDlg::PrepareCreateGame(BOOL create_game)
{
	((CButton*)GetDlgItem(IDC_RADIO_CREATEGAME))->SetCheck(create_game/*BST_CHECKED=1*/);
	((CButton*)GetDlgItem(IDC_RADIO_CONNECTGAME))->SetCheck(!create_game/*BST_UNCHECKED=0*/);
	GetDlgItem(IDC_COMBO_IP)->EnableWindow(FALSE);
}


//      
void CConnectDlg::SetDisconnect(BOOL disconnect)
{
	GetDlgItem(IDC_RADIO_AUTOCONNECT)->EnableWindow(!disconnect);
	GetDlgItem(IDC_RADIO_MANUALCONNECT)->EnableWindow(!disconnect);

	if(disconnect == TRUE)
	{
		GetDlgItem(IDC_RADIO_AUTOCONNECT)->EnableWindow(!disconnect);
		GetDlgItem(IDC_RADIO_MANUALCONNECT)->EnableWindow(!disconnect);
		GetDlgItem(IDC_RADIO_CREATEGAME)->EnableWindow(!disconnect);
		GetDlgItem(IDC_RADIO_CONNECTGAME)->EnableWindow(!disconnect);
		GetDlgItem(IDC_STATIC_TEXTIP)->EnableWindow(!disconnect);
		GetDlgItem(IDC_STATIC_TEXTNUMBERPORT)->EnableWindow(!disconnect);
		GetDlgItem(IDC_COMBO_IP)->EnableWindow(!disconnect);
		GetDlgItem(IDC_EDIT_NUMBERPORT)->EnableWindow(!disconnect);
		GetDlgItem(IDOK)->SetWindowText("");
	}
	else
	{
		if(m_AutoConnect == TRUE)
			PrepareAutoConnect(TRUE);
		else 
			PrepareAutoConnect(FALSE);

		GetDlgItem(IDOK)->SetWindowText("");
	}
	
}


void CConnectDlg::DoDataExchange(CDataExchange* pDX)
{
	// TODO: Add your specialized code here and/or call the base class

	CDialog::DoDataExchange(pDX);
	DDX_Text(pDX, IDC_EDIT_NUMBERPORT, m_NumberPort);
	DDX_Text(pDX, IDC_COMBO_IP, m_IP);
}

void CConnectDlg::OnOK()
{
	//      .
	UpdateData();

	if(m_NumberPort < 1024 || m_NumberPort > 49151)
	{
		AfxMessageBox("      1024 - 49151");
		return;
	}


	CDialog::OnOK();
}
