#include "StdAfx.h"
#include ".\directplay.h"
#include "ChildView.h"



#define SAFE_RELEASE(point) if(point!=NULL){point->Release(); point = NULL;}

//   DirectPlay    
//    .      
static const GUID g_guidApp = { 0xc32c8ec1, 0x2406, 0x498c, { 0x87, 0x30, 0x50, 0x8c, 0x4f, 0xa1, 0x1c, 0xf3 } };


//      CDirectPlay	   
//      callback function DirectPlay
CDirectPlay* g_pDirectPlay = NULL;

//    ,
//    ()
int g_NumberPlayers = 0;



//   (  callback)  DirectPlay,        ,
//     ( DPN_MSGID_PEER_INFO  , DPN_MSGID_RECEIVE   )
//           
//      ,
//     
HRESULT WINAPI DPMessageHandler( PVOID pvUserContext, DWORD dwMessageId, PVOID pMsgBuffer)
{
		
	switch(dwMessageId)
	{
		case DPN_MSGID_ENUM_HOSTS_RESPONSE:
		{		
			try
			{
				//        
				g_pDirectPlay->m_criticalEnumHosts.Lock();

				HRESULT hr = S_OK;
				PDPNMSG_ENUM_HOSTS_RESPONSE     pEnumHostsResponseMsg;
				
				pEnumHostsResponseMsg = (PDPNMSG_ENUM_HOSTS_RESPONSE) pMsgBuffer;

				DPN_APPLICATION_DESC* pAppDesc = NULL;
				pAppDesc = (DPN_APPLICATION_DESC*)pEnumHostsResponseMsg->pApplicationDescription;
	

				//       CDirectPlay::m_vecHostInfo,
				//         1 -
				// (CDirectPlay::EnumHosts  CDirectPlay::ConnectToHost())-
				for(int i = 0; i < (int)g_pDirectPlay->m_vecHostInfo.size(); i++)
				{
					if(g_pDirectPlay->m_vecHostInfo[i]->pAppDesc->guidInstance == pAppDesc->guidInstance)
					{
						goto exit;
					}
				}

				//      
				HOSTINFO* hinfo = new HOSTINFO;

				hinfo->pAppDesc = new DPN_APPLICATION_DESC;
				ZeroMemory(hinfo->pAppDesc, sizeof(DPN_APPLICATION_DESC));
				memcpy(hinfo->pAppDesc, pAppDesc, sizeof(DPN_APPLICATION_DESC));

				hr = pEnumHostsResponseMsg->pAddressSender->Duplicate(&hinfo->pHostAddress);

				//    ,     
				if(hr == S_OK)
				{
					GUID guidSP = {0};
					hr = hinfo->pHostAddress->GetSP(&guidSP);
					//       
					if(hr == S_OK && guidSP == CLSID_DP8SP_TCPIP)
					{
						g_pDirectPlay->m_vecHostInfo.push_back(hinfo);
					}
				}

				//	     
				exit:
				
				//       
				g_pDirectPlay->m_criticalEnumHosts.Unlock();
			}
			catch(...)
			{
				//    ,      
				g_pDirectPlay->m_criticalEnumHosts.Unlock();
			}

			
			
		}
		break;

		case DPN_MSGID_ASYNC_OP_COMPLETE:
			{
				try
				{
					//      ,
					//         
					//  
					g_pDirectPlay->m_criticalAsyngOpComplete.Lock();
					

					DPNMSG_ASYNC_OP_COMPLETE* pAsyngOpCompleteMsg = (DPNMSG_ASYNC_OP_COMPLETE*)pMsgBuffer;

					//      
					if(pAsyngOpCompleteMsg->hAsyncOp == g_pDirectPlay->m_hAsyngEnumHosts)
					{
						g_pDirectPlay->OnEnumHostComplete();

					}	 

					g_pDirectPlay->m_criticalAsyngOpComplete.Unlock();
				}
				catch(...)
				{
					g_pDirectPlay->m_criticalAsyngOpComplete.Unlock();
				}
				
			}
			break;
		case DPN_MSGID_INDICATE_CONNECT:
			{
				//     
				g_pDirectPlay->m_criticalIndicateConnect.Lock();

				//DPNMSG_INDICATE_CONNECT* pIndicateConnectMsg = (DPNMSG_INDICATE_CONNECT*)pMsgBuffer;
				PostMessage(g_pDirectPlay->m_pParent->m_hWnd, WM_DPN_MSGID_INDICATE_CONNECT, 0, 0);

				g_pDirectPlay->m_criticalIndicateConnect.Unlock();
			}
			break;

		
		case DPN_MSGID_CONNECT_COMPLETE:
			{		
				//     ,
				//       
				g_pDirectPlay->m_criticalConnectComplete.Lock();

				DPNMSG_CONNECT_COMPLETE* pConnectCompleteMsg = (DPNMSG_CONNECT_COMPLETE*)pMsgBuffer;

				if(g_pDirectPlay->m_hAsyngConnect ==  pConnectCompleteMsg->hAsyncOp)
				{
					g_pDirectPlay->OnConnectComplete(pConnectCompleteMsg->hResultCode);
				}
				
				PostMessage(g_pDirectPlay->m_pParent->m_hWnd, WM_DPN_MSGID_CONNECT_COMPLETE, pConnectCompleteMsg->hResultCode, 0);
				g_pDirectPlay->m_criticalConnectComplete.Unlock();
			}
			break;
		case DPN_MSGID_CREATE_PLAYER:
			{
				//    DPN_MSGID_INDICATE_CONNECT   
				//   DPN_MSGID_CONNECT_COMPLETE    .
				//        
				try
				{
					g_pDirectPlay->m_criticalCreatePlayer.Lock();

					//  
					g_NumberPlayers++;

					DPNMSG_CREATE_PLAYER* pCreatePlayerMsg = (DPNMSG_CREATE_PLAYER*)pMsgBuffer;

					//      
					DPN_PLAYER_INFO* player_info = NULL;
					g_pDirectPlay->GetPeerInfo(pCreatePlayerMsg->dpnidPlayer, &player_info);

					if(player_info == NULL)
					{
						((CChildView*)g_pDirectPlay->m_pParent)->m_Decoration.
						MessageWnd(" .  !.\n !", CMessageBox::MMB_OK);
						return S_OK;
					}

					//       ,
					//   (  ),
					//     ,
					//      
					if(g_pDirectPlay->m_Mode == CDirectPlay::modeIndefinitely)
					{
						//    ,   - 
						if((player_info->dwPlayerFlags & DPNPLAYER_HOST) == DPNPLAYER_HOST)
						{
							g_pDirectPlay->m_Mode = CDirectPlay::modeHost;
						}
						else if((player_info->dwPlayerFlags & DPNPLAYER_LOCAL) == DPNPLAYER_LOCAL)
						{
							g_pDirectPlay->m_Mode = CDirectPlay::modeClient;
						}
						
						//       
						g_pDirectPlay->m_IDLocalPlayer = pCreatePlayerMsg->dpnidPlayer;
							
					}// if(g_pDirectPlay->m_Mode == CDirectPlay::modeIndefinitely)

					
					//   
					//        
					g_pDirectPlay->m_IDPlayer = pCreatePlayerMsg->dpnidPlayer;

					//     
					//     CChildView::On_DPN_MSGID_CREATE_PLAYER
					//   ,      
					CDataPlayer* pDataPlayer = new CDataPlayer;
					if(g_pDirectPlay->m_Mode == CDirectPlay::modeHost)
					{
						memcpy(pDataPlayer, player_info->pvData, sizeof(CDataPlayer));
						pDataPlayer->m_IDPlayer = pCreatePlayerMsg->dpnidPlayer;
					}

					
					
					//      
					PostMessage(g_pDirectPlay->m_pParent->m_hWnd, WM_DPN_MSGID_CREATE_PLAYER, (WPARAM)pDataPlayer, 0);

					//    
					DELETEPOINT(player_info);

					g_pDirectPlay->m_criticalCreatePlayer.Unlock();
				}
				catch(...)
				{
					g_pDirectPlay->m_criticalCreatePlayer.Unlock();
				}
				
				
			}
			break;

		case DPN_MSGID_DESTROY_PLAYER:
			{
				//      
				g_pDirectPlay->m_criticalDestroyPlayer.Lock();

				DPNMSG_DESTROY_PLAYER* pDestroyPlayerMsg = (DPNMSG_DESTROY_PLAYER*)pMsgBuffer;
				g_pDirectPlay->m_IDPlayer = pDestroyPlayerMsg->dpnidPlayer;

				//       ,
				//        
				//    ,  .
				PostMessage(g_pDirectPlay->m_pParent->m_hWnd, WM_DPN_MSGID_DESTROY_PLAYER, 0, 0);

				g_pDirectPlay->m_criticalDestroyPlayer.Unlock();
			}
			break;

		case DPN_MSGID_PEER_INFO:
			{
				//  ,     
				//       ,
				// ,      ,
				//        
				//     DPN_MSGID_RECEIVE.
			
				g_pDirectPlay->m_criticalPeerInfo.Lock();

				DPNMSG_PEER_INFO* pPeerInfoMsg = (DPNMSG_PEER_INFO*)pMsgBuffer;
				//      ,
				//   -   DirectPlay::GetPeerInfo
				//   

				//     
				g_pDirectPlay->m_IDPlayer = pPeerInfoMsg->dpnidPeer;

				//       
				PostMessage(g_pDirectPlay->m_pParent->m_hWnd, WM_DPN_MSGID_PEER_INFO, 0, 0);

				g_pDirectPlay->m_criticalPeerInfo.Unlock();

			}
			break;

			
		case DPN_MSGID_RECEIVE:
			{
				//  ,    
				//  
				try
				{
					g_pDirectPlay->m_criticalReceive.Lock();

					DPNMSG_RECEIVE* pReceiveMsg = (DPNMSG_RECEIVE*) pMsgBuffer;

					// ..      
					//       .
					//        MSG_TYPE  
					//     
					MSG_TYPE* pSendBuffer = (MSG_TYPE*)malloc(pReceiveMsg->dwReceiveDataSize);

					//     ,    
					//      ,     .
					memcpy(pSendBuffer, pReceiveMsg->pReceiveData, pReceiveMsg->dwReceiveDataSize);

					//       ,
					//      .
					//       ,   -  
					if(pSendBuffer->msg_type == CDirectPlay::msgRequestIdle || pSendBuffer->msg_type == CDirectPlay::msgReplyIdle)
						PostMessage(g_pDirectPlay->m_pParent->m_hWnd, WM_MSGCHECKIDLE, pSendBuffer->msg_type, (LPARAM)pSendBuffer);
					else
						PostMessage(g_pDirectPlay->m_pParent->m_hWnd, WM_MSGSERVICEGAME, pSendBuffer->msg_type, (LPARAM)pSendBuffer);

					g_pDirectPlay->m_criticalReceive.Unlock();
				}
				catch(...)
				{
					g_pDirectPlay->m_criticalReceive.Unlock();
				}

				
			}
			break;

		case DPN_MSGID_HOST_MIGRATE:
			{
				//      
				//    
				g_pDirectPlay->m_criticalHostMigrate.Lock();

				DPNMSG_HOST_MIGRATE* pHostMigrateMsg = (DPNMSG_HOST_MIGRATE*)pMsgBuffer;

				//       
				if(pHostMigrateMsg->dpnidNewHost == g_pDirectPlay->m_IDLocalPlayer)
				{
					g_pDirectPlay->m_Mode = CDirectPlay::modeHost;
				}

				g_pDirectPlay->m_criticalHostMigrate.Unlock();
			}
			break;

	}// switch(dwMessageId)


	return S_OK;
}



CDirectPlay::CDirectPlay(void)
: m_pDP(NULL)
, m_hAsyngEnumHosts(NULL)
, m_hAsyngConnect(NULL)
, m_pParent(NULL)
, m_IDPlayer(0)
, m_IDLocalPlayer(0)
, m_NumberPort(2301)/*2302 - 2400 -  DirectPlay  */
, m_strAddress(_T("127.0.0.1"))
, m_StopProccess(false)
{
	//      
	g_pDirectPlay = this;
	m_Mode = CDirectPlay::modeIndefinitely;

	if(InitDirectPlay()	!= DPN_OK)
	{
		((CChildView*)m_pParent)->m_Decoration.
						MessageWnd("!  DirectX8  !", CMessageBox::MMB_OK);
	}

	srand((unsigned)time( NULL));
}

CDirectPlay::~CDirectPlay(void)
{
	if(m_pDP != NULL)
		m_pDP->Close(0);

	SAFE_RELEASE( m_pDP );
}

///////////////////////////////////////////////////////////////////////////////
//  ,     DirectPlay
///////////////////////////////////////////////////////////////////////////////
HRESULT CDirectPlay::InitDirectPlay(void)
{
	HRESULT hr = S_OK;

	//  MFC     
	// ..    COM   
	//     
	//CoInitializeEx(NULL, COINIT_MULTITHREADED);

	//  DirectPlay 
	hr = CoCreateInstance(	CLSID_DirectPlay8Peer, NULL, 
									CLSCTX_INPROC_SERVER,
									IID_IDirectPlay8Peer, 
									(LPVOID*) &m_pDP );
	if(hr != DPN_OK) return hr;

	//  DirectPlay  (callback function)DPMessageHandler, 
	//      
	hr = m_pDP->Initialize(NULL, DPMessageHandler, DPNINITIALIZE_HINT_LANSESSION);
	
	return hr;
}

//       DirectPlay
//     DirectPlay  .
HRESULT CDirectPlay::ReInitDirectPlay(void)
{
	HRESULT hr = InitDirectPlay();
	if(hr != DPN_OK) return hr;

	CChildView* pParent = (CChildView*)m_pParent;
	hr = pParent->m_DirectPlay.SetPlayerInfo(&pParent->m_Decoration.m_Player[0].m_DataPlayer);

	return hr;
}

//  DirectPlay  
HRESULT CDirectPlay::Disconnect(void)
{
	//   ,      
	//   .
	HRESULT hr = S_OK;
	if(m_pDP != NULL)
		hr = m_pDP->Close(0);

	if(hr != DPN_OK) return hr;

	SAFE_RELEASE( m_pDP );

	//   DirectPlay      
	//        
	m_Mode = CDirectPlay::modeIndefinitely;
	hr = ReInitDirectPlay();
	if(hr == DPN_OK)
		m_NumberPort = 2301;

	return hr;
}
//-----------------------------------------------------------------------------


///////////////////////////////////////////////////////////////////////////////
//  ,   
///////////////////////////////////////////////////////////////////////////////

//  -.
HRESULT CDirectPlay::CreateHost(void)
{
	HRESULT hr = E_NOTIMPL;

	//     IP-   
	m_IPCompInfo.GetIPComputer();
	int number_address = (int)m_IPCompInfo.m_vecAddressAndMask.size();
	LPDIRECTPLAY8ADDRESS*  pLocalHostAddress = new LPDIRECTPLAY8ADDRESS[number_address];

	//     DirectPlay     127.0.0.1,
	//          (127.0.0.1).
	for(int i = 0; i < number_address; i++)
	{
		hr = CreateDeviceAddress(m_NumberPort, &pLocalHostAddress[i], inet_ntoa(m_IPCompInfo.m_vecAddressAndMask[i].iaddr));
	}

	if(hr != S_OK) return hr;
	
	//    .
	DPN_APPLICATION_DESC    dpAppDesc;
	ZeroMemory(&dpAppDesc, sizeof(DPN_APPLICATION_DESC));
	dpAppDesc.dwSize = sizeof(DPN_APPLICATION_DESC);
	dpAppDesc.dwFlags = DPNSESSION_MIGRATE_HOST|DPNSESSION_NODPNSVR;
	
	dpAppDesc.guidApplication = g_guidApp;
	dpAppDesc.dwMaxPlayers = MAXPLAYERS; //    

	hr = m_pDP->Host(&dpAppDesc, 
					pLocalHostAddress,	//   
					number_address,		//   
					NULL, NULL, NULL, 0);
	

	for(int i = 0; i < number_address; i++)
		SAFE_RELEASE(pLocalHostAddress[i]);

	delete[] pLocalHostAddress;
	pLocalHostAddress = NULL;


	if(hr != S_OK)
	{
		//      
		if(m_ConnectDlg.m_AutoConnect == FALSE)
		{
			if(hr == DPNERR_INVALIDDEVICEADDRESS)
			{
				((CChildView*)m_pParent)->m_Decoration.
						MessageWnd("   .\n  .", CMessageBox::MMB_OK);
			}
			else
			{
				((CChildView*)m_pParent)->m_Decoration.
						MessageWnd("  !", CMessageBox::MMB_OK);
			}
		}

		//       .
		ReInitDirectPlay();

	}
	else
	{
		//       .
		CChildView* pParent = (CChildView*)m_pParent;
		pParent->m_SearchPlayers.ShowSearchPlayers(false);
	}

	return hr;
}

//   ,
//       
//    
void CDirectPlay::AutoCreateHost(void)
{
	if(m_StopProccess == true) return;

	HRESULT hr = S_OK;

attempt_again:

	hr = CreateHost();

	if(hr != S_OK)
	{
		//         
		//       
		if(m_NumberPort < MAXNUMBERPORT)
		{
			m_NumberPort++;
			goto attempt_again;
		}
		else
		{
			//     ,      
			//       
			m_NumberPort = BEGINNUMBERPORT;
			CChildView* pParent = (CChildView*)m_pParent;
			pParent->m_SearchPlayers.ShowSearchPlayers(false);
			((CChildView*)m_pParent)->m_Decoration.MessageWnd("   !", CMessageBox::MMB_OK);
		}
		
	}// if(hr != S_OK)
	
}

//      IP-  
HRESULT CDirectPlay::DoConnect( IDirectPlay8Address*  pHostAddress, DPN_APPLICATION_DESC*  dpnAppDesc)
{
	HRESULT hr = E_NOTIMPL;
	LPDIRECTPLAY8ADDRESS  pDeviceAddress = NULL;
	//      ,
	//    
	hr = CreateDeviceAddress(0, &pDeviceAddress, "");

	if(hr == S_OK)
		hr = m_pDP->Connect(dpnAppDesc, pHostAddress, pDeviceAddress,    
											NULL, NULL, NULL, 0,  NULL,               
											NULL, &m_hAsyngConnect, 0); 

	return hr;
}

//    ,
//     .
HRESULT CDirectPlay::ConnectToHost(void)
{
	//       ,
	//   ,  .
	((CChildView*)m_pParent)->m_SearchPlayers.SetText(" !");
	if(CSearchPlayers::staticCountProcess == 0)
		((CChildView*)m_pParent)->m_SearchPlayers.ShowSearchPlayers(true);


	DPN_APPLICATION_DESC    dpAppDesc;
	IDirectPlay8Address*  pHostAddress  = NULL;

	HRESULT hr = S_OK;
	LPDIRECTPLAY8ADDRESS  pDeviceAddress = NULL;

	//       .
	hr = CreateDeviceAddress(0, &pDeviceAddress, "");
	if(hr != S_OK) return hr;
	
	//   .
	//   .
	if(m_ConnectDlg.m_AutoConnect == TRUE)
	{
		m_IPCompInfo.GetIPComputer();

		//      ,
		//          ,
		//      - "127.0.0.1".
		if(CString(inet_ntoa(m_IPCompInfo.m_vecAddressAndMask[0].iaddr_mask)) == "127.255.255.255")
			m_strAddress = "127.0.0.1";
		else
			m_strAddress = "255.255.255.255"; //inet_ntoa(m_IPCompInfo.m_vecAddressAndMask[0].iaddr_mask); //    
	}
	

	//        .
	hr = CreateHostAddress(&pHostAddress, m_strAddress.GetBuffer(), m_NumberPort);
	if(hr != S_OK) return hr;

	//    ,
	//     dpAppDesc.guidApplication 
	//        .
	ZeroMemory(&dpAppDesc, sizeof(DPN_APPLICATION_DESC));
	dpAppDesc.dwSize = sizeof(DPN_APPLICATION_DESC);
	dpAppDesc.guidApplication = g_guidApp;


	hr = m_pDP->EnumHosts(	&dpAppDesc,		
							pHostAddress,	
							pDeviceAddress,   
							NULL, 0,           
							1,					//   
							5,					//   
							5,					//    
							NULL,  
							&m_hAsyngEnumHosts,	//    
							0);					 

	//      
	SAFE_RELEASE(pHostAddress);


	return hr;
}

//      
HRESULT CDirectPlay::OnEnumHostComplete(void)
{
	HRESULT hr = E_NOTIMPL;
	
	//       , ,  .
	if(m_vecHostInfo.size() > 0)
	{
		
		TCHAR* host_address = new TCHAR[256];
		ZeroMemory(host_address, 256*sizeof(TCHAR));
		GetAddressPort(m_vecHostInfo[0]->pHostAddress, host_address);
		m_strAddress = host_address;

		//   .
		if(m_vecHostInfo.size() > 1)
		{
			((CChildView*)m_pParent)->m_Decoration.MessageWnd("   !", CMessageBox::MMB_OK);
		}


		//      , , -  ,
		if(hr == DPNSUCCESS_PENDING)
		{
			((CChildView*)m_pParent)->m_SearchPlayers.SetText(" !");
		}

		//     ,
		//       CDirectPlay::OnConnectComplete().
		hr = DoConnect(m_vecHostInfo[0]->pHostAddress, m_vecHostInfo[0]->pAppDesc);


		 
		//      .
		for(int i = 0; i < (int)m_vecHostInfo.size(); i++)
		{
			m_vecHostInfo[i]->pHostAddress->Release();
			delete m_vecHostInfo[i]->pAppDesc;
			delete ((HOSTINFO*) m_vecHostInfo[i]);
		}
		
		m_vecHostInfo.clear();   
		delete[] host_address;

		
	}// if(m_vecHostInfo.size() > 0)
	else
	{
		//       ,
		//     ,
		//     E_FAIL.
		OnConnectComplete(E_FAIL);
	}

	return hr;
}

//     , 
//           
void CDirectPlay::OnConnectComplete(HRESULT return_connect)
{
	//         ,
	//         
	//  .
	//     - ,
	//        ( IDirectPlay::EnumHosts).
	// DirectPlay   ,   
	//      ,    
	//   .
	if(return_connect != S_OK)
	{
		//      ,
		//        
		//  .
		if(m_ConnectDlg.m_AutoConnect == FALSE)
		{
			CString str_message;
			switch(return_connect)
			{
			case DPNERR_SESSIONFULL: 
				str_message = "     !\n  !";
				break;
			case E_FAIL:	
				str_message = "   !\n  ()  .";
				break;
			}

			CChildView* pParent = (CChildView*)m_pParent;
			pParent->m_SearchPlayers.ShowSearchPlayers(false);
			pParent->m_Decoration.MessageWnd(str_message, CMessageBox::MMB_OK);
		
			return;
		}

		//       
		//   .

		if(m_StopProccess == true) return;
		
		//       ,
		//         .
		if(m_NumberPort < MAXNUMBERPORT)
		{
			m_NumberPort++;
			ConnectToHost();
		}
		//     ,
		//   ().
		else
		{

			((CChildView*)m_pParent)->m_SearchPlayers.SetText(" !");
			Sleep(1000); //            .

			

			//     .
			m_NumberPort = BEGINNUMBERPORT;	

			//   .
			AutoCreateHost();
				
		}
	}
	else
	{
		//   ,    .
		CChildView* pParent = (CChildView*)m_pParent;
		pParent->m_SearchPlayers.ShowSearchPlayers(false);
	}
}

//          
void CDirectPlay::DoNetwork(void)
{
	//    
	m_ConnectDlg.m_Caption = " ";

	//   - 
	if(m_Mode == modeHost)
	{
		m_ConnectDlg.m_Caption = "-";
		//     IP-(m_NumberPort & m_strAddress)  
		GetHostAddressesPort();
	}
	else if(m_Mode == modeClient)
	{
		m_ConnectDlg.m_Caption = "-";

		int num_player = ((CChildView*)m_pParent)->m_Decoration.m_NUMBERPLAYERS;
		for(int i = 0; i < num_player; i++)
		{
			DWORD id_player = ((CChildView*)m_pParent)->m_Decoration.m_Player[i].m_DataPlayer.m_IDPlayer;
			DPN_PLAYER_INFO* pinfo = NULL;
			GetPeerInfo(id_player, &pinfo);

			if(pinfo == NULL) return;

			//          
			if(pinfo->dwPlayerFlags == DPNPLAYER_HOST)
			{
				IDirectPlay8Address* pAddress = NULL;
				m_pDP->GetPeerAddress(id_player, &pAddress, 0);
				TCHAR ch[256]={0};
				GetAddressPort(pAddress, ch, &m_NumberPort); 
				m_strAddress = ch;
				delete pinfo;
				break;
			}
		}

		
	}



	//         
	if(m_Mode == CDirectPlay::modeIndefinitely)
	{
		m_ConnectDlg.m_IsConnect = FALSE;
		m_IPCompInfo.GetIPComputer();
		for(int i = 0; i < (int)m_IPCompInfo.m_vecAddressAndMask.size(); i++)
			m_ConnectDlg.m_vecListIP.push_back(inet_ntoa(m_IPCompInfo.m_vecAddressAndMask[i].iaddr));

		//    
		//     
		m_ConnectDlg.m_NumberPort = m_NumberPort;
	}
	else
	{
		m_ConnectDlg.m_IsConnect = TRUE;
		//    
		//     
		m_ConnectDlg.m_NumberPort = m_NumberPort;
		m_ConnectDlg.m_IP = m_strAddress;
	}

	

	if(m_ConnectDlg.DoModal() == IDOK)
	{
		//    ,  
		if(m_ConnectDlg.m_IsConnect == FALSE)
		{

			//    
			if(m_ConnectDlg.m_AutoConnect == TRUE)
			{
				ConnectToHost();
			}
			else if(m_ConnectDlg.m_CreateGame == TRUE)
			{
				m_NumberPort = m_ConnectDlg.m_NumberPort;
				m_strAddress = m_ConnectDlg.m_IP;
				CreateHost();
			}
			else if(m_ConnectDlg.m_CreateGame == FALSE)
			{
				m_strAddress = m_ConnectDlg.m_IP;
				m_NumberPort = m_ConnectDlg.m_NumberPort;
				ConnectToHost();
			}
		}
		else
		{
			Disconnect();
		}

	}// if(m_ConnectDlg.DoModal() == IDOK)

}

//-----------------------------------------------------------------------------

///////////////////////////////////////////////////////////////////////////////
//  
///////////////////////////////////////////////////////////////////////////////

//        
HRESULT CDirectPlay::GetHostAddressesPort(void)
{
	HRESULT hr = E_NOTIMPL;

	DWORD number_address = 0;
	LPDIRECTPLAY8ADDRESS*  pLocalHostAddress = NULL;
	hr = m_pDP->GetLocalHostAddresses(pLocalHostAddress, &number_address, DPNGETLOCALHOSTADDRESSES_COMBINED); 
	if(hr == DPNERR_BUFFERTOOSMALL)
	{
		pLocalHostAddress = new LPDIRECTPLAY8ADDRESS[number_address];
		hr = m_pDP->GetLocalHostAddresses(pLocalHostAddress, &number_address, DPNGETLOCALHOSTADDRESSES_COMBINED); 
		if(hr == S_OK)
		{
			for(int i = 0; i < (int)number_address; i++)
			{
				TCHAR host_address[256] = {0};
				GetAddressPort(pLocalHostAddress[i], host_address, &m_NumberPort/* */);
				m_strAddress/* */ = host_address;

				break;
			}
		}

		for(int i = 0; i < (int)number_address; i++)
			SAFE_RELEASE(pLocalHostAddress[i]);

		delete[] pLocalHostAddress;
	}

	return hr;
}


//     
HRESULT CDirectPlay::CreateDeviceAddress(DWORD port, IDirectPlay8Address**  ppDeviceAddress, CString address)
{
	HRESULT hr = CoCreateInstance( CLSID_DirectPlay8Address, NULL, CLSCTX_INPROC_SERVER,
									IID_IDirectPlay8Address,(LPVOID*) ppDeviceAddress );
	if(hr == S_OK)
	{
		//   
		hr = (*ppDeviceAddress)->SetSP(&CLSID_DP8SP_TCPIP );

		if(hr == S_OK && port > 0)
		{
			//    
			hr = (*ppDeviceAddress)->AddComponent(DPNA_KEY_PORT, &port, sizeof(DWORD), DPNA_DATATYPE_DWORD);

			if(hr != S_OK) return hr;

			WCHAR  wstrBuffer[128] = {0};
			MultiByteToWideChar( CP_ACP, 0, address.GetBuffer(), -1, wstrBuffer, 128);
			

			// IP-     
			if( wcslen( wstrBuffer ) > 0 )
			{
				hr = (*ppDeviceAddress)->AddComponent( DPNA_KEY_HOSTNAME, wstrBuffer,
															2*((UINT)wcslen(wstrBuffer) + 1), /*bytes*/
															DPNA_DATATYPE_STRING );
				if(hr != S_OK) return hr;
			}

		}// if(hr == S_OK && port > 0)
	}

	return hr;
}

//    
HRESULT CDirectPlay::CreateHostAddress(IDirectPlay8Address** ppHostAddress, TCHAR* szAddress, DWORD dwRemotePort)
{
	HRESULT hr = E_NOTIMPL;
	
	hr = CoCreateInstance( CLSID_DirectPlay8Address, NULL, CLSCTX_INPROC_SERVER,
								IID_IDirectPlay8Address,(LPVOID*) ppHostAddress );
                                       
    if(hr != S_OK) return hr;


	//   
	hr = (*ppHostAddress)->SetSP(&CLSID_DP8SP_TCPIP);
	if(hr != S_OK) return hr;


	WCHAR  wstrBuffer[128] = {0};
	MultiByteToWideChar( CP_ACP, 0, szAddress, -1, wstrBuffer, 128);

    //       
    if( wcslen( wstrBuffer ) > 0 )
    {
        hr = (*ppHostAddress)->AddComponent( DPNA_KEY_HOSTNAME, wstrBuffer,
                                                       2*((UINT)wcslen(wstrBuffer) + 1), /*bytes*/
                                                       DPNA_DATATYPE_STRING );
        if(hr != S_OK) return hr;
    }

    //   
    if( dwRemotePort != 0 )
    {
        hr = (*ppHostAddress)->AddComponent( DPNA_KEY_PORT, &dwRemotePort,
                                            sizeof(DWORD), DPNA_DATATYPE_DWORD );
                                                       
       if(hr != S_OK) return hr;
    }

	return hr;
}

//      
HRESULT CDirectPlay::GetPeerInfo(DPNID id_player, DPN_PLAYER_INFO** player_info)
{
	ASSERT(player_info != NULL);
	
	DWORD dwSize = 0;
	HRESULT hr = m_pDP->GetPeerInfo(id_player, NULL, &dwSize, 0);
	if(hr == DPNERR_BUFFERTOOSMALL)
	{
		
		(*player_info) = (DPN_PLAYER_INFO*)new unsigned char[dwSize];
		ZeroMemory((*player_info), dwSize);
		(*player_info)->dwSize = sizeof(DPN_PLAYER_INFO);
		hr = m_pDP->GetPeerInfo(id_player, (*player_info), &dwSize, 0);
	}

	return hr;
}

//    
HRESULT CDirectPlay::SetPeerInfo(DPN_PLAYER_INFO* const player_info)
{
	m_pDP->SetPeerInfo(player_info, NULL, NULL, DPNSETPEERINFO_SYNC);
	
	return E_NOTIMPL;
}

//        CDataPlayer
//   DPN_MSGID_PEER_INFO
HRESULT CDirectPlay::SetPlayerInfo(CDataPlayer* const player_data)
{
	DPN_PLAYER_INFO player_info;
	ZeroMemory( &player_info, sizeof(DPN_PLAYER_INFO));
	player_info.dwSize = sizeof(DPN_PLAYER_INFO);
	player_info.dwPlayerFlags = 0;
	player_info.dwInfoFlags = DPNINFO_DATA;
	player_info.pvData = player_data;
	player_info.dwDataSize = sizeof(CDataPlayer);


	return m_pDP->SetPeerInfo(&player_info, NULL, NULL, DPNSETPEERINFO_SYNC);
}

//      CDataPlayer
HRESULT CDirectPlay::GetPlayerInfo(DPNID id_player, CDataPlayer* player_data)
{
	//   ,     
	DPN_PLAYER_INFO* player_info = NULL;
	
	DWORD size = 0;
	//       DPN_PLAYER_INFO
	HRESULT hr = m_pDP->GetPeerInfo(id_player, NULL, &size, 0);
	if(hr == DPNERR_BUFFERTOOSMALL)
	{
		//     
		player_info = (DPN_PLAYER_INFO*)new char[size];
		ZeroMemory(player_info, size);
		player_info->dwSize = sizeof(DPN_PLAYER_INFO);
		hr = m_pDP->GetPeerInfo(id_player, player_info, &size, 0);

		if(hr == S_OK)
			memcpy(player_data, player_info->pvData, sizeof(CDataPlayer));
			
		delete player_info;

	}// if(hr == DPNERR_BUFFERTOOSMALL)

	
	return hr;
}


//         
HRESULT CDirectPlay::SetPlayerName(TCHAR* szPlayerName)
{
	HRESULT hr = E_NOTIMPL;
	if(m_pDP == NULL) return hr;

	DPN_PLAYER_INFO p_info;
	ZeroMemory( &p_info, sizeof(DPN_PLAYER_INFO) );
	p_info.dwSize = sizeof(DPN_PLAYER_INFO);
	p_info.dwInfoFlags = DPNINFO_NAME;

	WCHAR wstrName[128];
	MultiByteToWideChar( CP_ACP, 0, szPlayerName, -1, wstrName, 128);                          
	p_info.pwszName = wstrName;

	return m_pDP->SetPeerInfo(&p_info, NULL, NULL, DPNOP_SYNC);
}

//     
HRESULT CDirectPlay::GetCurrentPLayers(DWORD* number_players)
{
	HRESULT hr = E_NOTIMPL;
	DPN_APPLICATION_DESC app_desc;   
	ZeroMemory(&app_desc,  sizeof(DPN_APPLICATION_DESC));
	app_desc.dwSize = sizeof(DPN_APPLICATION_DESC);
	
	DWORD size = 0;
	//     DPN_APPLICATION_DESC
	hr = m_pDP->GetApplicationDesc(NULL, &size, 0);
	if(hr == DPNERR_BUFFERTOOSMALL)
	{
		hr = m_pDP->GetApplicationDesc(&app_desc, &size, 0);

		if(hr == S_OK)
		{
			*number_players = app_desc.dwCurrentPlayers;
		}
		else
			*number_players = 2;

		
	}

	return hr;
}

//  MAX  
HRESULT CDirectPlay::GetMaxPlayers(DWORD* dwMaxPlayers)
{
	HRESULT hr = E_NOTIMPL;
	(*dwMaxPlayers) = 0;

	DWORD dwSize = 0;
	hr = m_pDP->GetApplicationDesc(NULL, &dwSize, 0);
	if(hr != DPNERR_BUFFERTOOSMALL)
		return hr;


	DPN_APPLICATION_DESC* AppDesc = (DPN_APPLICATION_DESC*) new BYTE[dwSize];
	ZeroMemory(AppDesc, dwSize);
	AppDesc->dwSize = sizeof(DPN_APPLICATION_DESC);
	hr = m_pDP->GetApplicationDesc(AppDesc, &dwSize, 0);
	if(hr != S_OK) return hr;

	*dwMaxPlayers = AppDesc->dwMaxPlayers;

	DELETEPOINT(AppDesc);

	return hr;
}

//  IP-      IDirectPlay8Address
HRESULT CDirectPlay::GetAddressPort(IDirectPlay8Address* const prgpAddress, TCHAR* ip_address, DWORD* number_port)
{
	HRESULT hr = E_NOTIMPL;
	DWORD size;
	DWORD type;
	WCHAR* pwszName = NULL;

	if(ip_address != NULL)
	{
		//  IP- 
		WCHAR url[256]= {0};
		size = 0;
		pwszName = L"hostname";
		type = DPNA_DATATYPE_STRING;
		hr = prgpAddress->GetComponentByName(pwszName, url, &size, &type);
		if(hr == DPNERR_BUFFERTOOSMALL)
		{
			hr = prgpAddress->GetComponentByName(pwszName, url, &size, &type);
			if(hr != S_OK) return hr;
			memcpy(ip_address, CString(url).GetBuffer(), CString(url).GetLength()*sizeof(TCHAR));
		}
	}

	if(number_port != NULL)
	{
		//    
		size = 0;
		pwszName = L"port";
		type = DPNA_DATATYPE_DWORD;
		hr = prgpAddress->GetComponentByName(pwszName, &number_port, &size, &type);
		if(hr == DPNERR_BUFFERTOOSMALL)
		{
			hr = prgpAddress->GetComponentByName(pwszName, number_port, &size, &type);
		}

		
	}

	return hr;
}


//    
HRESULT CDirectPlay::SendToGroup(void* send_data, const DWORD& size_data, bool noloopback)
{
	return SendToPlayer(DPNID_ALL_PLAYERS_GROUP, send_data, size_data, noloopback);
}

//    
HRESULT CDirectPlay::SendToPlayer(DPNID id_player, void* send_data, const DWORD& size_data, bool noloopback)
{
	HRESULT hr = E_NOTIMPL;
	DPN_BUFFER_DESC dpnBuffer;
	
    dpnBuffer.pBufferData  = (BYTE*)send_data;
    dpnBuffer.dwBufferSize = size_data;

	DWORD flag = 0;
	flag |= DPNSEND_GUARANTEED;
	if(noloopback == true)
		flag |= DPNSEND_NOLOOPBACK;

	DPNHANDLE handle;
    hr = m_pDP->SendTo(id_player, &dpnBuffer, 
                        1, 0, NULL, &handle, flag); 
	

	return hr;
}

