#include "StdAfx.h"
#include ".\ipcompinfo.h"

CIPCompInfo::CIPCompInfo(void)
{
}

CIPCompInfo::~CIPCompInfo(void)
{
}


//  IP-  
//   IP-        AddressAndMask,
//           IP-
void CIPCompInfo::GetIPComputer(void)
{
	//       
	MIB_IPADDRTABLE* IpAddrTable = NULL;
	ULONG dwSize = 0;
	m_vecAddressAndMask.clear();
	AddressAndMask address_and_mask;

	//     ,   
	//      127.0.0.1     
	//   DirectPlay  
	if(GetIpAddrTable(IpAddrTable, &dwSize, FALSE) == ERROR_INSUFFICIENT_BUFFER)
	{
		IpAddrTable = new MIB_IPADDRTABLE[dwSize];
		if(GetIpAddrTable(IpAddrTable, &dwSize, FALSE) == NO_ERROR)
		{
			for(int i = 0; i < IpAddrTable->dwNumEntries; i++)
			{
				if(IpAddrTable->table[i].dwAddr == 0)
					continue;
				else
				{
					//     AddressAndMask    
					//    
					address_and_mask.iaddr.S_un.S_addr = IpAddrTable->table[i].dwAddr;
					address_and_mask.iaddr_mask.S_un.S_addr = 
						AddressTo_MaskAddres(IpAddrTable->table[i].dwAddr, IpAddrTable->table[i].dwMask);
					
					//     
					m_vecAddressAndMask.push_back(address_and_mask);
				}
			}
		}// if(GetIpAddrTable(IpAddrTable, &dwSize, TRUE) == NO_ERROR)

		delete IpAddrTable;
		IpAddrTable = NULL;
				
	}// if(GetIpAddrTable(&IpAddrTable, &dwSize, FALSE) == ERROR_INSUFFICIENT_BUFFER)
	
}

//   IP-   
DWORD CIPCompInfo::AddressTo_MaskAddres(DWORD address, DWORD mask)
{
	//      
	//  IP- 120.100.78.1    255.255.0.0
	//     120.100.255.255
	//   255.255.255.0 - 120.100.78.255 

	in_addr iaddr;
	in_addr iaddr_mask;
	
	iaddr.S_un.S_addr = address;
	iaddr_mask.S_un.S_addr = mask;
	
	UCHAR index[4]; 
	index[0] = iaddr_mask.S_un.S_un_b.s_b1;
	index[1] = iaddr_mask.S_un.S_un_b.s_b2;
	index[2] = iaddr_mask.S_un.S_un_b.s_b3;
	index[3] = iaddr_mask.S_un.S_un_b.s_b4;

	UCHAR addr[4]; 
	addr[0] = iaddr.S_un.S_un_b.s_b1;
	addr[1] = iaddr.S_un.S_un_b.s_b2;
	addr[2] = iaddr.S_un.S_un_b.s_b3;
	addr[3] = iaddr.S_un.S_un_b.s_b4;

	for(int m = 0; m < 4; m++)
	{
		if(index[m] == 0)
			addr[m] = 255;
	}
	
	iaddr.S_un.S_un_b.s_b1 = addr[0];
	iaddr.S_un.S_un_b.s_b2 = addr[1];
	iaddr.S_un.S_un_b.s_b3 = addr[2];
	iaddr.S_un.S_un_b.s_b4 = addr[3];
	

	return  (DWORD)iaddr.S_un.S_addr;
}