// MainFrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include "NineKNet1.h"

#include "MainFrm.h"
#include ".\mainfrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


const int MINWIDTH  = 680;
const int MINHEIGHT = 520;

// CMainFrame

IMPLEMENT_DYNAMIC(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	ON_WM_CREATE()
	ON_WM_SETFOCUS()
	ON_WM_GETMINMAXINFO()
	ON_WM_CLOSE()
	ON_WM_NCHITTEST()
	ON_WM_TIMER()
END_MESSAGE_MAP()

// CMainFrame construction/destruction

CMainFrame::CMainFrame()
: m_AllowClose(false)
{
	// TODO: add member initialization code here
}

CMainFrame::~CMainFrame()
{
}


int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	// create a view to occupy the client area of the frame
	if (!m_wndView.Create(NULL, NULL, AFX_WS_DEFAULT_VIEW,
		CRect(0, 0, 0, 0), this, AFX_IDW_PANE_FIRST, NULL))
	{
		TRACE0("Failed to create view window\n");
		return -1;
	}
	
	if (!m_wndToolBar.CreateEx(this, TBSTYLE_FLAT, WS_CHILD | WS_VISIBLE | CBRS_TOP | CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC) ||
		!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}

	SetWindowText(APPTITLE);

	ReadSettingFromReg();


	return 0;
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	if( !CFrameWnd::PreCreateWindow(cs) )
		return FALSE;
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	cs.dwExStyle &= ~WS_EX_CLIENTEDGE;
	cs.lpszClass = AfxRegisterWndClass(0);
	return TRUE;
}


// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif //_DEBUG


// CMainFrame message handlers

void CMainFrame::OnSetFocus(CWnd* /*pOldWnd*/)
{
	// forward focus to the view window
	m_wndView.SetFocus();
}

BOOL CMainFrame::OnCmdMsg(UINT nID, int nCode, void* pExtra, AFX_CMDHANDLERINFO* pHandlerInfo)
{
	//      ,
	//    
	if(m_wndView.IsAllowActiveChildView() == true)
	{
		if (m_wndView.OnCmdMsg(nID, nCode, pExtra, pHandlerInfo))
			return TRUE;
	}
	
	return CFrameWnd::OnCmdMsg(nID, nCode, pExtra, pHandlerInfo);
}

void CMainFrame::OnGetMinMaxInfo(MINMAXINFO* lpMMI)
{
	CRect rc1;
	rc1.left   = 0;
	rc1.top    = 0;
	rc1.right  = MINWIDTH;
	rc1.bottom = MINHEIGHT;
	
   //      ( )
	CalcWindowRect(&rc1, CWnd::adjustOutside );

	lpMMI->ptMinTrackSize.x = rc1.Width();
	lpMMI->ptMinTrackSize.y = rc1.Height();

	CFrameWnd::OnGetMinMaxInfo(lpMMI);
}



//     
void CMainFrame::WriteSettingToReg(void)
{
	HKEY hkey;

    if( ERROR_SUCCESS == RegCreateKeyEx( HKEY_CURRENT_USER, APP_REGKEY_PUBLIC, 
        0, NULL, REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, NULL, &hkey, NULL ) )
    {
       
		WINDOWPLACEMENT wp;
		this->GetWindowPlacement(&wp);
		Util_WriteIntRegKey( hkey, TEXT("Left"),     wp.rcNormalPosition.left);
		Util_WriteIntRegKey( hkey, TEXT("Top"),	     wp.rcNormalPosition.top);
		Util_WriteIntRegKey( hkey, TEXT("Width"),    wp.rcNormalPosition.right);
        Util_WriteIntRegKey( hkey, TEXT("Height"),   wp.rcNormalPosition.bottom);
		Util_WriteIntRegKey( hkey, TEXT("ShowMode"), wp.showCmd);

		

        RegCloseKey( hkey );
    }
}

//    
void CMainFrame::ReadSettingFromReg(void)
{
	HKEY hkey;
    if( ERROR_SUCCESS == RegCreateKeyEx( HKEY_CURRENT_USER, APP_REGKEY_PUBLIC, 
        0, NULL, REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, NULL, &hkey, NULL ) )
    {
		WINDOWPLACEMENT wp;
		Util_ReadIntRegKey( hkey, TEXT("Left"),    (DWORD*)&wp.rcNormalPosition.left,  100);
		Util_ReadIntRegKey( hkey, TEXT("Top"),     (DWORD*)&wp.rcNormalPosition.top,   100);
		Util_ReadIntRegKey( hkey, TEXT("Width"),   (DWORD*)&wp.rcNormalPosition.right,  MINWIDTH);
		Util_ReadIntRegKey( hkey, TEXT("Height"),  (DWORD*)&wp.rcNormalPosition.bottom, MINHEIGHT);
		
		this->SetWindowPlacement(&wp);

        RegCloseKey( hkey );
    }

}

void CMainFrame::OnClose()
{
	
	//              ,
	//       CApp::OnIdle
	//       ,
	//    ,    
	if(m_AllowClose == false)
	{
		//         
		//  ,
		//       
		//if(m_wndView.m_GamePlayer == true)
		if(m_wndView.m_Decoration.m_Player[0].m_DataPlayer.m_GamePlayer == true)
			m_wndView.SendStopProcess();


		//   ,
		//      , 
		//        "m_wndView.SendStopProcess()"
		if(m_wndView.m_Decoration.m_NUMBERPLAYERS < 2)
			m_wndView.StopGame();

		//      
		SetTimer(ID_TIMER_CLOSEAPP, 100, NULL);

		//    
		ShowWindow(SW_HIDE);
	}
	else
	{
		WriteSettingToReg();
		CFrameWnd::OnClose();
	}

}

void CMainFrame::OnTimer(UINT nIDEvent)
{
	//      
	//    
	if(nIDEvent == ID_TIMER_CLOSEAPP)
	{
		if(m_wndView.IsStopGame() == true && m_wndView.m_DistrOk == true)
		{
			KillTimer(ID_TIMER_CLOSEAPP);
			m_AllowClose = true;
			OnClose();
		}

		//    15      
		//    
		static int count = 0;
		count++;
		if(count == 150)
		{
			KillTimer(ID_TIMER_CLOSEAPP);
			DestroyWindow();
		}
	}

	//    ..    
	//        
	//      

	// CFrameWnd::OnTimer(nIDEvent);
}
