// Text.cpp : implementation file
//

#include "stdafx.h"
#include "Label.h"
#include ".\label.h"


// CLabel

CLabel::CLabel()
: m_pParent(NULL)
, m_colorText(0)
, m_ShowText(true)
, m_Shade(false)
, m_OffsetShade(4)
, m_Flag(0)
, X(0)
, Y(0)
{
	m_Rect.SetRectEmpty();
}

CLabel::~CLabel()
{
	if(m_Font.m_hObject != NULL)
		m_Font.DeleteObject();
}

// CLabel message handlers
void CLabel::Draw(CDC* pDC)
{
	if(m_ShowText == false) return;

	CFont* pdefFont = pDC->SelectObject(&m_Font);
	COLORREF def_color = pDC->SetTextColor(m_colorText);
	int def_bkmode = pDC->GetBkMode();
	pDC->SetBkMode(TRANSPARENT);

	
	if(m_Shade == true)
	{
		pDC->SetTextColor(RGB(0,0,0));
		pDC->DrawText(m_DrawText, &CRect(m_Rect.left+m_OffsetShade, m_Rect.top+m_OffsetShade, 
											m_Rect.right+m_OffsetShade, m_Rect.bottom+m_OffsetShade) , DT_CENTER);
		pDC->SetTextColor(m_colorText);
	}

	pDC->DrawText(m_DrawText, &m_Rect, DT_CENTER);

	pDC->SetBkMode(def_bkmode);
	pDC->SetTextColor(def_color);
	pDC->SelectObject(pdefFont);
}

void CLabel::RepaintText(CRect rc)
{
	if(m_pParent != NULL)
	{
		if(m_Shade == false)
			m_pParent->InvalidateRect(&rc, TRUE);
		else
			m_pParent->InvalidateRect(&CRect(rc.left, rc.top, 
											rc.right+m_OffsetShade, rc.bottom+m_OffsetShade), TRUE);
	}
}

void CLabel::SetText(const CString& text)
{
	_settext(text, true);
}

void CLabel::_settext(const CString& text, bool main_text)
{
	//    
	CRect rc_oldrepaint(&m_Rect);

	if(text != "")
	{
		m_DrawText = text;
		if(main_text == true)
			m_memoryText = text;
	}

	//    
	CDC* pDC = m_pParent->GetDC();
	CFont* pFont = pDC->SelectObject(&m_Font);
	CSize szText = pDC->GetOutputTextExtent(m_DrawText);

	CRect rc_temp;
	rc_temp.left = X;
	//         
	//  
	if(m_Flag == 1)
		rc_temp.left = X - szText.cx/2;

	rc_temp.top  = Y;

	rc_temp.right  = rc_temp.left + szText.cx;
	rc_temp.bottom = rc_temp.top  + szText.cy;
	m_Rect.SetRect(rc_temp.left, rc_temp.top, rc_temp.right, rc_temp.bottom);

	//   GDI
	pDC->SelectObject(pFont);
	m_pParent->ReleaseDC(pDC);

	//      
	RepaintText(&rc_oldrepaint);
	RepaintText(&m_Rect);
		
}

void CLabel::SetPos(int x, int y, int flag)
{
	X = x;
	Y = y;
	m_Flag = flag;
	_settext("", true);
}

void CLabel::InitText(CWnd* pParent)
{
	m_pParent = pParent;
}

void CLabel::SetFontText(int height, CString name, int bold)
{
	LOGFONT logfont;
	memset(&logfont, 0, sizeof(LOGFONT));
	logfont.lfHeight = height;    
	logfont.lfWeight = bold;
	logfont.lfCharSet = RUSSIAN_CHARSET;
	strcpy(logfont.lfFaceName, name);
	SetFontText(logfont);
}

void CLabel::SetFontText(const LOGFONT& logfont)
{
	if(m_Font.m_hObject != NULL)
		m_Font.DeleteObject();

	m_Font.CreateFontIndirect(&logfont);
}

//  
void CLabel::SetWidthFont(int width)
{
	LOGFONT logfont;
	m_Font.GetLogFont(&logfont);
	logfont.lfWidth = width;
	SetFontText(logfont);
}


void CLabel::OnTimer(UINT  nIDEvent)
{
	if(nIDEvent == 5)
	{
		m_pParent->KillTimer(5);
		SetText(m_memoryText);
	}
}

void CLabel::SetTempText(CString temp_text)
{
	_settext(temp_text, false);
	m_pParent->SetTimer(5, 750, NULL);
}

void CLabel::ShowText(bool show)
{
	m_ShowText = show;
	RepaintText(&m_Rect);
}

void CLabel::SetShade(bool shade)
{
	m_Shade = shade;
	RepaintText(&m_Rect);
}
