#pragma once
#include "nine.h"
#include "vector"


const int CARDWIDTH  = 71;
const int CARDHEIGHT = 96;

// CCard

class AFX_CLASS_EXPORT CCard : public CWnd
{
	DECLARE_DYNAMIC(CCard)

public:
	CCard();
	CCard(const CCard& copy);
	virtual ~CCard();

protected:
	DECLARE_MESSAGE_MAP()
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
public:
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	BOOL __fastcall CreateCard(CRect rc, CWnd* parent, UINT ID_FACE, UINT ID_SHIRT);
	void __fastcall SetBmp(UINT ID_FACE, UINT ID_SHIRT);
private:
	bool m_bMove;
	int m_X;
	int m_Y;
	CBitmap m_bmpFace;
	CBitmap m_bmpShirt;
	bool m_bIsFace;
	
public:
	afx_msg BOOL OnEraseBkgnd(CDC* pDC);
	void __fastcall CardMove(int left, int top, bool quickspeed);
	CPoint GetCardPos(void);
	void SetCardPos(const CPoint& ptPos);
	void __fastcall SetCardPos(const int& x, const int& y);
	void CardOpen(bool open, int card_width=0, int card_height=0);
	int m_Value; //    6, 7, 8, 9, 10, ,   ..
	int m_Mast; // 
	int m_Player;
	//         
	// .. 6-7-8-9-10----
	int m_PosValue;
	HRESULT DrawImage(HDC hdc, const RECT& rcBounds);
	CComPtr<IPicture> m_pPicture;
	//       .. ,  ,  ..
	int m_State;
	
public:
	//       
	void CardClose(const bool& close);
	void ShowCard(bool show);
	//   
	bool m_bOpenningCard;
	bool m_bAnimCards;
	
	
private:
	//   
	void __fastcall DoOpenCard(const bool& open, const int& card_width=0, const int& card_height=0);
public:
	//      
	void ResetCardSize(int card_width=0, int card_height=0);

	//    
	static bool staticStopProcess;
	//    
	static int staticCountProcess;
	//        .
	static bool staticSound;

	//     
	void CardMoveSound(int left, int top, int mode_sound);
};

class  AFX_CLASS_EXPORT CPack
{
public:
	CPack(void);
	~CPack(void);

public:
	
	//  
	enum ValueDurak{m_durak6=1, m_durak7, m_durak8, m_durak9, m_durak10, m_durakV, m_durakD, m_durakK, m_durakT};
	//      X
	int m_PackPosX;
	//      Y
	int m_PackPosY;
	
	std::vector<CCard*> m_vecPack;

	//  
	enum StateCards{m_Indefinitely,
					m_ePack=10,				//   
					m_eTable,				//    
					m_ePlayer};				//     
	
	//   
	bool InitPack36(CWnd* pParent);
	
	//      
	void __fastcall SetPackPos(const int& x, const int& y);
	
	//    !
	void __fastcall CardsToPack(void);

	//      
	CCard* GetCard(const int& index);

	//      
	CCard* TakeCard(int *index_card);

	//     
	void __fastcall ShufflePack();


	//     ( )
	void ShufflePack(char mast[], char value[]);
	//     ( )
	void __fastcall ArrayShuffle(char mast[], char value[]);
private:
	//    
	unsigned char m_NUMBERCARDS;
public:

	//     
	int GetNumberCardsInPack(void)
	{
		return (int)m_vecPack.size()/*m_NUMBERCARDS*/;
	}
	//      ,   ,     ..
	void __fastcall OpenAllCards(bool open_all);
private:
	int m_ID_Shirt;
public:
	//   
	bool SetShirt(const int number);
	int GetShirt(void);

	//          CPack
	void ShowAinmationCards(bool animation);
	//     
	bool IsShowAinmationCards(void);
	//     
	bool IsPackFull(void);

};
