#include "StdAfx.h"
#include ".\player.h"

CDataPlayer::CDataPlayer(void)
: m_IDPlayer(0)
, m_Money(0)
, m_NumberVictory(0)
, m_NumberRoll(0)
, m_GamePlayer(false)
{
	ZeroMemory(m_Name, MAXCHARNAMES*sizeof(TCHAR));
}

CDataPlayer::~CDataPlayer(void)
{
}


/////////////////////////////////
CPlayer::CPlayer(void)
: m_pBankPlayer(NULL)
{
	m_pBankPlayer = new CBankPlayer();
}

CPlayer::~CPlayer(void)
{
	DELETEPOINT(m_pBankPlayer);
}


void CPlayer::SetParent(CWnd* pParent)
{
	m_Name.InitText(pParent);
	m_Name.SetColorText(RGB(255,255,0));
	m_Name.SetFontText(20, "Times New Roman", 400);
	m_Name.SetShade(true);

	m_LabelMoney.InitText(pParent);
	m_LabelMoney.SetColorText(RGB(255,255,0));
	m_LabelMoney.SetFontText(16, "Arial", 600); //"Times New Roman");
	m_LabelMoney.SetShade(true);
	
	m_pBankPlayer->InitBankPlayer(pParent);
	m_pBankPlayer->SetMoney(0);

}

//    
void CPlayer::SetMoney(const int& money)
{
	CString s;
	s.Format("%d", money);
	CString S;
	S += s;
	S += ".";
	m_LabelMoney.SetText(S);

	m_DataPlayer.m_Money = money;
	m_pBankPlayer->SetMoney(money);
}



int CPlayer::GetMoney(void)
{
	return m_DataPlayer.m_Money;
}

void CPlayer::SetNumberVictory(const int& number_victory)
{
	m_DataPlayer.m_NumberVictory = number_victory;
}

int CPlayer::GetNumberVictory(void)
{
	return m_DataPlayer.m_NumberVictory;
}

void CPlayer::SetNumberRoll(const int& number_roll)
{
	m_DataPlayer.m_NumberRoll = number_roll;
}

int CPlayer::GetNumberRoll(void)
{
	return m_DataPlayer.m_NumberRoll;
}

//   
void CPlayer::SetName(CString name)
{
	strcpy(m_DataPlayer.m_Name, name.GetBuffer());
	m_Name.SetText(m_DataPlayer.m_Name);
}

//   
CString CPlayer::GetName(void)
{
	return CString(m_DataPlayer.m_Name);
}

//        (    .)
void CPlayer::Show(bool show)
{
	m_Name.ShowText(show);
	m_LabelMoney.ShowText(show);
	m_pBankPlayer->Show(show);
}

//   ,     ..   
void CPlayer::SetPos(const CPoint& pos)
{
	m_ptPos = pos;
	
	m_Name.SetPos(pos.x, pos.y, 1);
	m_pBankPlayer->SetPos(pos.x - m_pBankPlayer->m_Size.cx/2, pos.y + 35);
	m_LabelMoney.SetPos(pos.x, pos.y+17, 1);
}
//   
void CPlayer::CopyDataPlayer(const CDataPlayer& data_player)
{
	memcpy(&m_DataPlayer, &data_player, sizeof(CDataPlayer));
	SetName(m_DataPlayer.m_Name);
	SetMoney(m_DataPlayer.m_Money);
}

void CPlayer::SetDC(CDC* pDC)
{
	m_Name.Draw(pDC);
	m_LabelMoney.Draw(pDC);
}
